Attribute VB_Name = "HashAlgo"
Option Explicit

Dim sbox(255)
Dim key(255)

Private Type MD5_CTX
    State(1 To 4) As Double
    Count(1 To 2) As Double
    Buffer(1 To 64) As Integer
End Type
Private t(1 To 64) As Double
Private Const UpBound = 4294967296#
Private Const S11 = 7
Private Const S12 = 12
Private Const S13 = 17
Private Const S14 = 22
Private Const S21 = 5
Private Const S22 = 9
Private Const S23 = 14
Private Const S24 = 20
Private Const S31 = 4
Private Const S32 = 11
Private Const S33 = 16
Private Const S34 = 23
Private Const S41 = 6
Private Const S42 = 10
Private Const S43 = 15
Private Const S44 = 21
Private PADDING(1 To 64) As Integer
Private Context As MD5_CTX

Private Const md5 = 0
Private Const sha = 1
Private Const all_range = 0
Private Const sel_range = 1
Private Const md5_header = "-----MD5-----"
Private Const sha_header = "-----SHA-----"
Private Const header_len = 13

Private bufA As Double
Private bufB As Double
Private bufC As Double
Private bufD As Double
Private bufE As Double

'Holds the Hash Value
Private sign_msg As String


Private Sub Ttable()
Dim i As Integer
  t(1) = UpBound - Abs(&HD76AA478)
  t(2) = UpBound - Abs(&HE8C7B756)
  t(3) = &H242070DB
  t(4) = UpBound - Abs(&HC1BDCEEE)
  t(5) = UpBound - Abs(&HF57C0FAF)
  t(6) = &H4787C62A
  t(7) = UpBound - Abs(&HA8304613)
  t(8) = UpBound - Abs(&HFD469501)
  t(9) = &H698098D8
  t(10) = UpBound - Abs(&H8B44F7AF)
  t(11) = UpBound - Abs(&HFFFF5BB1)
  t(12) = UpBound - Abs(&H895CD7BE)
  t(13) = &H6B901122
  t(14) = UpBound - Abs(&HFD987193)
  t(15) = UpBound - Abs(&HA679438E)
  t(16) = &H49B40821
  t(17) = UpBound - Abs(&HF61E2562)
  t(18) = UpBound - Abs(&HC040B340)
  t(19) = &H265E5A51
  t(20) = UpBound - Abs(&HE9B6C7AA)
  t(21) = UpBound - Abs(&HD62F105D)
  t(22) = &H2441453
  t(23) = UpBound - Abs(&HD8A1E681)
  t(24) = UpBound - Abs(&HE7D3FBC8)
  t(25) = &H21E1CDE6
  t(26) = UpBound - Abs(&HC33707D6)
  t(27) = UpBound - Abs(&HF4D50D87)
  t(28) = &H455A14ED
  t(29) = UpBound - Abs(&HA9E3E905)
  t(30) = UpBound - Abs(&HFCEFA3F8)
  t(31) = &H676F02D9
  t(32) = UpBound - Abs(&H8D2A4C8A)
  t(33) = UpBound - Abs(&HFFFA3942)
  t(34) = UpBound - Abs(&H8771F681)
  t(35) = &H6D9D6122
  t(36) = UpBound - Abs(&HFDE5380C)
  t(37) = UpBound - Abs(&HA4BEEA44)
  t(38) = &H4BDECFA9
  t(39) = UpBound - Abs(&HF6BB4B60)
  t(40) = UpBound - Abs(&HBEBFBC70)
  t(41) = &H289B7EC6
  t(42) = UpBound - Abs(&HEAA127FA)
  t(43) = UpBound - Abs(&HD4EF3085)
  t(44) = &H4881D05
  t(45) = UpBound - Abs(&HD9D4D039)
  t(46) = UpBound - Abs(&HE6DB99E5)
  t(47) = &H1FA27CF8
  t(48) = UpBound - Abs(&HC4AC5665)
  t(49) = UpBound - Abs(&HF4292244)
  t(50) = &H432AFF97
  t(51) = UpBound - Abs(&HAB9423A7)
  t(52) = UpBound - Abs(&HFC93A039)
  t(53) = &H655B59C3
  t(54) = UpBound - Abs(&H8F0CCC92)
  t(55) = UpBound - Abs(&HFFEFF47D)
  t(56) = UpBound - Abs(&H85845DD1)
  t(57) = &H6FA87E4F
  t(58) = UpBound - Abs(&HFE2CE6E0)
  t(59) = UpBound - Abs(&HA3014314)
  t(60) = &H4E0811A1
  t(61) = UpBound - Abs(&HF7537E82)
  t(62) = UpBound - Abs(&HBD3AF235)
  t(63) = &H2AD7D2BB
  t(64) = UpBound - Abs(&HEB86D391)
  
  PADDING(1) = &H80
  For i = 2 To 64
    PADDING(i) = 0
  Next i
End Sub


Private Sub MD5Init()
Dim i As Integer
    Context.Count(1) = 0
    Context.Count(2) = 0
    Context.State(1) = &H67452301
    Context.State(2) = UpBound - Abs(&HEFCDAB89)
    Context.State(3) = UpBound - Abs(&H98BADCFE)
    Context.State(4) = &H10325476
        For i = 1 To 64
            Context.Buffer(i) = 0
        Next i
End Sub


Private Sub MD5Transform()
   
    Dim a As Double
    Dim b As Double
    Dim c As Double
    Dim d As Double
    Dim temp As Double
    Dim X(1 To 16) As Double
    Dim times, j As Integer
    Dim i, k, s As Integer
    a = Context.State(2)
    b = Context.State(3)
    c = Context.State(4)
    d = Context.State(1)
       For j = 0 To 15
            X(j + 1) = 0
            X(j + 1) = Context.Buffer(j * 4 + 1) * (2 ^ 24)
            X(j + 1) = X(j + 1) + Context.Buffer(j * 4 + 2) * (2 ^ 16)
            X(j + 1) = X(j + 1) + Context.Buffer(j * 4 + 3) * (2 ^ 8)
            X(j + 1) = X(j + 1) + Context.Buffer(j * 4 + 4)
        Next j
        'Round 1
        Call FF(a, b, c, d, X(1), S11, t(1))
        Call FF(d, a, b, c, X(2), S12, t(2))
        Call FF(c, d, a, b, X(3), S13, t(3))
        Call FF(b, c, d, a, X(4), S14, t(4))
        Call FF(a, b, c, d, X(5), S11, t(5))
        Call FF(d, a, b, c, X(6), S12, t(6))
        Call FF(c, d, a, b, X(7), S13, t(7))
        Call FF(b, c, d, a, X(8), S14, t(8))
        Call FF(a, b, c, d, X(9), S11, t(9))
        Call FF(d, a, b, c, X(10), S12, t(10))
        Call FF(c, d, a, b, X(11), S13, t(11))
        Call FF(b, c, d, a, X(12), S14, t(12))
        Call FF(a, b, c, d, X(13), S11, t(13))
        Call FF(d, a, b, c, X(14), S12, t(14))
        Call FF(c, d, a, b, X(15), S13, t(15))
        Call FF(b, c, d, a, X(16), S14, t(16))
        'Round 2
        Call GG(a, b, c, d, X(2), S21, t(17))
        Call GG(d, a, b, c, X(7), S22, t(18))
        Call GG(c, d, a, b, X(12), S23, t(19))
        Call GG(b, c, d, a, X(1), S24, t(20))
        Call GG(a, b, c, d, X(6), S21, t(21))
        Call GG(d, a, b, c, X(11), S22, t(22))
        Call GG(c, d, a, b, X(16), S23, t(2   C1), S1A= &K1f), S233Da, X(1), S24, t(20))
       ,0(9), S11, t(9))
        Call FF((15))
        F((-n
  T32C5CR      Call FF((15)3Call FF((15)3Call )
       d  Call FF((15)3Cal30fund - Abs(, c, X(14), S12, t(14))
 32Context.Buffer(j * 4 + 2) * (ll GG(d, a, b, c, X(11h2p)y d, X(9cl4, t(20))
       ,0(9), SD  Call FF((15)3Cal30fund - Abs(, c, X(14g yp5   455